 import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)

/**
 * clase AnimatedActor para la animacion de los actores para que se vean movimiento de estos
 * 
 * @author: Martinez Garcia Dulce Mayra Janet
 * @author: Guerrero Martinez Argel
 * 
 * @version 6 Dic 2010
 */
public class AnimatedActor extends Mover
{
    private GreenfootImage[] images;
    private int currentImage = 0;
    
    /**
     * metodo para la animacion de las imagenes, 
     * recibe el nombre base de las imagenes, el tipo de archivo, y el numero total de imagenes
     */
    public void Animated(String basename, String suffix, int noOfImages)
    {
        images = new GreenfootImage[noOfImages];
        for(int i=0; i < noOfImages; i++) {
            images[i] = new GreenfootImage(basename + i + suffix);
        }     
    }
    
    /**
     * metodo actua para las imagenes de los actores
     */    
    public void act() 
    {
        currentImage = (currentImage + 1) % images.length;
        setImage(images[currentImage]);
    }
}
  


