import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Clase Coraline es el jugador princpila del juego
 * 
 * @author: Martinez Garcia Dulce Mayra Janet
 * @author: Guerrero Martinez Argel
 * 
 * @version 6 Dic 2010
 */
public class Coraline  extends Heroe
{
    /**
     * Act - do whatever the Coraline wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    
    GreenfootImage imagenAbrir;
    GreenfootImage imagenCerrar;
    GreenfootImage imagenAbrir2;
    GreenfootImage imagenCerrar2;
    GreenfootImage imagenArriba0;
    GreenfootImage imagenArriba1;
    protected boolean camina = false;
    protected boolean bandera = false;
    protected boolean banderaMuere=false;
    
    protected boolean estado=true;
    protected boolean estadoM=false;
    
    private int contador=0;
        
    /**
     * constructor de la clase Coraline recibe como parametro el mundo.
     * se crean las imagenes de coraline
     */
    public Coraline(Fondo mun)
    {
        Mundo=mun;
        imagenCerrar = new GreenfootImage("coralineA.png");
        imagenAbrir = new GreenfootImage("coralineB.png");
        imagenCerrar2 = new GreenfootImage("coralineA2.png");
        imagenAbrir2 = new GreenfootImage("coralineB2.png");
        imagenArriba0= new GreenfootImage("coralineArriba0.png");
        imagenArriba1= new GreenfootImage("coralineArriba1.png");
       
    }
    
    /**
     * metodo para cambiar de imagen cuando avanza Coraline hacia la derecha
     */
    public void cambiaPasoDer()
    {
        if(camina==false)
         {
             setImage(imagenCerrar);
             camina=true;
         }
       else
       {
         if(camina)
          {
              setImage(imagenAbrir);
             camina=false;
          }
       }
    }
    
    /**
     * metdo para cambiar de imagen cuando coraline z hacia la izquierda
     */
    public void cambiaPasoIzq()
    {
        if(camina==false)
         {
             setImage(imagenCerrar2);
             camina=true;
         }
       else
       {
         if(camina)
          {
              setImage(imagenAbrir2);
             camina=false;
          }
       }
    }
    
    /**
     * metodo para cambiar de imagenes cuando coraline sube y baja escaleras
     */
    public void cambiaArriba()
    {
        if(camina==false)
         {
             setImage(imagenArriba0);
             camina=true;
         }
       else
       {
         if(camina)
          {
              setImage(imagenArriba1);
             camina=false;
          }
       }
    }
    
    /**
     *metodo actua
     *checa si presionan alguna tecla para mover a coraline derecha, izquierda, arriba y abajo
     *si se presiona la tecla espacio crea hachas
     */
    public void act() 
    {
        // Add your action code here.
       String mov;
       Actor a = getOneIntersectingObject(Bases.class);
       

       Hacha ha = new Hacha(bandera);
      
       mov= Greenfoot.getKey();
       
      //{
       if(a==null)
       {
           setLocation(getX(), getY()+6);
       }

       if(Greenfoot.isKeyDown("up"))
       {
             //Greenfoot.playSound("escalera.mp3");
           Actor c = getOneIntersectingObject(Escaleras.class);
               if(c!=null)
               {
                  if(bandera==false)     
                     bandera=true;
                  setLocation(getX(),getY()-10);
                  this.cambiaArriba();
               }
       } 
       
       if(Greenfoot.isKeyDown("down"))
       {
           //Greenfoot.playSound("escalera.mp3");
           Actor d = getOneIntersectingObject(Escaleras.class);
               if(d!=null)
               {
                  if(bandera==false)     
                     bandera=true;
                  setLocation(getX(),getY()+10);
                  this.cambiaArriba();
               }
       }
       
       if(Greenfoot.isKeyDown("left"))
       {
               if(bandera==false)     
                    bandera=true;
               setLocation(getX()-10, getY());
               this.cambiaPasoIzq();
       }
       if(Greenfoot.isKeyDown("right"))
       {
               if(bandera==true);
                   bandera=false;
               setLocation(getX()+10, getY());
               this.cambiaPasoDer();
       }
       
       if(Greenfoot.isKeyDown("space"))
       {
           Greenfoot.playSound("disparo.mp3");
           if(bandera)
                 Mundo.addObject(ha, getX()-10,getY()); 
           else
           {
               if(!bandera)
                  Mundo.addObject(ha, getX()+10,getY());  //bandera para direccion de la hacha
           }
       }    
       
       muereCoraline();
    }    
    
    /**
     * metodo para tener un contador 
     * para cuando el juego debe acabar si toca a los enemigos un cierto numero de veces
     */
    public void muereCoraline()
    {
       Actor b = getOneIntersectingObject(Enemigos.class);
       Actor c = getOneIntersectingObject(EnemigosPrincipales.class);
      
       if(b!=null || c!=null)
       {
               if(banderaMuere==false)
               {
                    banderaMuere=true;
                    if(contador<3) 
                    {
                        contador+=1;
                    }
                    else 
                        Mundo.JuegoFinal(1);
             }
       }
       else
       {
           banderaMuere=false;
       }
    }
}
