import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

/**
 * Fonfdo es la clase donde se crea todo el escenario, es el mundo
 * 
 * @author: Martinez Garcia Dulce Mayra Janet
 * @author: Guerrero Martinez Argel
 * 
 * @version 6 Dic 2010
 */

       
public class Fondo  extends World
{

    /**
     * constructor de Fondo, pantalla de tamao 800 x 600
     * se coloca el fondo de pantalla y una animacion de welcome para iniciar el juego
     * 
     */
    // GreenfootSound a= new GreenfootSound("nivel1_1.mp3");
     //GreenfootSound b= new GreenfootSound("nivel2.mp3");
     //GreenfootSound c= new GreenfootSound("nivel3.mp3");
  
    public Fondo()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(800, 600, 1);
        
        
        setBackground("fondoPort.jpg");
        Welcome wel=new Welcome(this);
        
        addObject(wel,470,500);
        
        
    }

   
   /**
    * Metodo menu donde se coloca varios botones para manipular el juego, ya sea ir a la ayuda o al juego directamente
    * 
    */
    public void menu()
    {
        limpiaEscenario();
        
        setBackground("fondoMenu.jpg");
        Inicio ini= new Inicio(this);
        Ayuda ayu= new Ayuda(this);
        Start st= new Start();
        Help he= new Help();
        
        addObject(ini,420,130);
        addObject(ayu,420,303);
        addObject(st,540,130);
        addObject(he,540,303);
    }
    
    /**
     * Metodo para quitar del escenario todos los onjetos que existan en el mundo
     * 
     */
    public void limpiaEscenario()
    {
        List objetos= this.getObjects(Actor.class);
        removeObjects(objetos);
    }
    
    /**
     * Metodo para manipular el juego en cada uno de los niveles...
     * ayuda mucho para cuando coraline llega a la meta y tiene que pasar al siguiente nivel.
     */
    public void Juego(int ban)//int band
    {
         
         switch(ban)
         {
             case 0: Nivel1();
                     break;

             case 1: Nivel2();
                     break;   
                     
             case 2: Nivel3();
                     break;
        }
    }
    
    /**
     * Metodo para manipular la ayuda del juego.
     * crea un nueva pantalla y un boton para iniciar el juego
     */
    public void Ayuda()
    {
        limpiaEscenario();
        
        setBackground("fondoAyuda.png");
        
        textoAyuda texto=new textoAyuda();
        addObject(texto,358,259);
        
        Inicio ini= new Inicio(this);
        Start st= new Start();
        
        addObject(ini,624,543);
        addObject(st,725,549);
    }
    
    /**
     * Nivel 1
     * agrega todos los objetos de adorno del juego
     * y los objetos principales que actuan en el juego
     */
    public void Nivel1()
    {
        limpiaEscenario();
        //a.play();
                     setBackground("nivel1.jpg");
                     Coraline cor= new Coraline(this);
                     Fantasma1 fanty1= new Fantasma1(this);
                     
                     Mantis mantis = new Mantis();
                     
                     Piso pi1 = new Piso();
                     Piso pi2 = new Piso();
                     Piso2 pis1 = new Piso2();
                     Piso2 pis2 = new Piso2();
                     Planta pla = new Planta();
                     Planta pla2 = new Planta();
                     Planta pla3 = new Planta();
                     Planta pla4 = new Planta();
                     Planta pla5 = new Planta();
                     Arbol ar1 = new Arbol();
                     Arbol ar2 = new Arbol();
                     Arbol ar3 = new Arbol();
                     Suelo sue1 = new Suelo();
                     Suelo sue2 = new Suelo();
                     Suelo sue3 = new Suelo();
                     Arbol2 arb1 = new Arbol2();
                     Arbol2 arb2 = new Arbol2();
                     Arbusto2 arbu1 = new Arbusto2();
                     Arbusto2 arbu2 = new Arbusto2();
                     Arbusto2 arbu3 = new Arbusto2();
                     Arbusto2 arbu4 = new Arbusto2();
                     Arbusto2 arbu5 = new Arbusto2();
                     Arbusto2 arbu6 = new Arbusto2();
                     Arbusto2 arbu7 = new Arbusto2();
                     Arbusto2 arbu8 = new Arbusto2();
                     
                     EscaleraTroncos escalera= new EscaleraTroncos();
                     EscaleraTroncos escalera2= new EscaleraTroncos();
                     
                     Carnivora car1=new Carnivora();
                     Carnivora car2=new Carnivora();
                     Carnivora car3=new Carnivora();
                     Carnivora car4=new Carnivora();
                     Carnivora car5=new Carnivora();
                     
                     Base2 base1= new Base2();
                     Base2 base2= new Base2();
                     Base2 base3= new Base2();
                     Base2 base4= new Base2();
                     
                     Base3 base=new Base3();
                    
                     Base1 baseEsc1= new Base1();
                     Base1 baseEsc2= new Base1();
                     Base1 baseEsc3= new Base1();
                     Base1 baseEsc4= new Base1();
                     Base1 baseEsc5= new Base1();
                     Base1 baseEsc6= new Base1();
                     Base1 baseEsc7= new Base1();
                     Base1 baseEsc8= new Base1();
                     Base1 baseEsc9= new Base1();
                     Base1 baseEsc10= new Base1();
                     

                     
                    
                     // bases de las plataformas
                     
                     addObject(base,428,599);
                     
                     
                     addObject(base1,291,391);
                     addObject(base2,635,391);
                     addObject(base3,173,169);
                     addObject(base4,486,169);
                     
                     addObject(baseEsc1,30,508);
                     addObject(baseEsc2,30,575);
                     addObject(baseEsc3,30,442);
                     addObject(baseEsc4,30,420);
                     addObject(baseEsc5,30,384);
                     
                     
                     addObject(baseEsc6,699,332);
                     addObject(baseEsc7,699,292);
                     addObject(baseEsc8,699,252);
                     addObject(baseEsc9,699,212);
                     addObject(baseEsc10,699,173);

                     //escaleras
                     
                     addObject(escalera,698,273);
                     addObject(escalera2,32,468);
                     
                     //PISO SUPEROR
                     addObject(sue1,116,172);
                     addObject(sue2,332,172);
                     addObject(sue3,547,172);
                     addObject(arb1,137,98);
                     addObject(arb2,433,105);
                     
                     addObject(arbu1,11,148);
                     addObject(arbu2,649,148);
                     
                     
                     //PLANTA BAJA
                     addObject(ar1,403,524);
                     addObject(ar2,762,524);
                     addObject(ar3,92,524);
                     addObject(pla,401,584);
                     //addObject(pla,141,495);
                     addObject(pla2,679,473);
                     
                     addObject(pla4,493,365);
                     addObject(pi2,615,584);
                     addObject(pi1,191,584);
                  
                     addObject(arbu3,12,564);
                     addObject(arbu4,789,563);
                     
                     //PISO MEDIO
                     addObject(pis1,245,378);
                     addObject(pis2,631,378);
                     addObject(pla3,430,380);
                      //plantas carnivoras
                     
                     addObject(car1,603,356);
                     addObject(car2,227,356);
                     addObject(car3,187,552);
                     addObject(car4,700,552);
                     addObject(car5, 549, 139);
                     
                     //coraline, fantasma  y mantis
                     addObject(cor,400,560);
                     addObject(fanty1,52,103);
                     addObject(mantis,237,106);
                     
                     addObject(arbu5,458,376);
                     addObject(arbu6,85,362);
                     addObject(arbu7,791,362);
                     addObject(arbu8,437,152);
    }
    
    /**
     * posiciona todos los objetos del juego
     * y los objetos que actuan en el.
     */
    public void Nivel2()
    {
       // a.stop();
      limpiaEscenario();
      //b.play();
         setBackground("cueba.png");
        Coraline cor2= new Coraline(this);
        
                   //bases
        Base1 baseEsc1= new Base1();
        Base1 baseEsc2= new Base1();
        Base1 baseEsc3= new Base1();
        Base1 baseEsc4= new Base1();
        Base1 baseEsc5= new Base1();
        Base1 baseEsc6= new Base1();
        Base1 baseEsc7= new Base1();
        Base1 baseEsc8= new Base1();
        Base1 baseEsc9= new Base1();
        Base1 baseEsc10= new Base1();
                     
                     
        
        Base3 base1=new Base3();
        Base3 base2=new Base3();
        Base3 base3=new Base3();
        addObject(base1,453,206);
        addObject(base2,428,384);
        addObject(base3,428,594);
    
        addObject(baseEsc1,772,555);
        addObject(baseEsc2,772,517);
        addObject(baseEsc3,772,481);
        addObject(baseEsc4,772,443);
        addObject(baseEsc5,772,407);
        
                     
        addObject(baseEsc6,47,335);
        addObject(baseEsc7,47,309);
        addObject(baseEsc8,47,283);
        addObject(baseEsc9,47,247);
        addObject(baseEsc10,47,210);
        
            
            
            
        Roca1 roca1 = new Roca1();
        Roca1 roca2 = new Roca1();
        Roca2 roc1 = new Roca2();
        Roca2 roc2 = new Roca2();
        Roca2 roc3 = new Roca2();
        Roca2 roc4 = new Roca2();
                       
        Roca2 roc5 = new Roca2();
        Roca2 roc6 = new Roca2();
        Roca2 roc7 = new Roca2();
        Roca2 roc8 = new Roca2();
        Roca2 roc9 = new Roca2();
        Roca2 roc10 = new Roca2();
                       
        Piedra1 pied1 = new Piedra1(); 
        Piedra1 pied2 = new Piedra1();
        Piedra1 pied3 = new Piedra1();
        Rata rat1 = new Rata();
        Rata rat2 = new Rata();
        Rata rat3 = new Rata();
        Rata rat4 = new Rata();
        Rata rat5 = new Rata();
        Rata rat6 = new Rata();
        Escalera esca1 = new Escalera();
        Escalera esca2 = new Escalera();
        Piedra2 med1 = new Piedra2();
        Piedra2 med2 = new Piedra2();
        Piedra3 sup1 = new Piedra3();
        Piedra3 sup2 = new Piedra3();
        Estalactita esta1 = new Estalactita();
        Estalactita esta2 = new Estalactita();
        Estalactita esta3 = new Estalactita();
        Estalagmita mig1 = new Estalagmita();
        Estalagmita mig2 = new Estalagmita();
        Estalagmita mig3 = new Estalagmita();
        Fantasma2 fanty  = new Fantasma2(this);
        
        
 
        
        SenB sr = new SenB();
                       
        addObject(esca2, 39, 266);
        addObject(mig1, 84, 36);
        addObject(mig2, 392, 36);
        addObject(mig3, 716, 36);
        addObject(fanty, 776, 148);
        addObject(sup1, 282, 208);
        addObject(sup2, 630, 208);
        addObject(esta1, 96, 192);
        addObject(esta2, 448, 192);
        addObject(esta3, 771, 192);
        addObject(roc5, 41, 379);
        addObject(roc6, 364, 379);
        addObject(roc7, 452, 379);
        addObject(roc8, 727, 379);
        addObject(roc9, 450, 207);
        addObject(roc10, 94, 202);
        addObject(pied1, 183,589);
        addObject(pied2, 404,589);
        addObject(pied3, 625,589);
        addObject(med1, 207,382);
        addObject(med2, 569,382);
        addObject(roc1, 23, 582);
        addObject(roc2, 56, 582);
        addObject(roc3, 783, 582);
        addObject(roc4, 747, 582);
                       
                       
        addObject(esca1, 771, 474);
                       
        addObject(roca1, 38,379);
        addObject(roca2, 410,379);
        addObject(rat1, 632, 568);
        addObject(rat2, 393, 568);
        addObject(rat3, 545, 357);
        addObject(rat4, 178, 357);
        addObject(rat5, 319, 568);
        addObject(rat6, 280, 180);
                       
                       
        addObject(sr, 585, 149);
        addObject(cor2, 103,560);
                       
    }
    
    /**
     * Agrega los objetos en el nivel,
     * tanto los objetos que actuan como los que solo estan de adorno en el nivel
     */
    public void Nivel3()
    {
        //b.stop();
      limpiaEscenario();
      
      //c.play();
      
        setBackground("telarana.png");
       
        
        Catarina cata = new Catarina();
        
        
        Catarina2 cata1 = new Catarina2();
        Catarina2 cata2 = new Catarina2();
        Catarina2 cata3 = new Catarina2();
        Catarina4 cata4 = new Catarina4();
        Catarina4 cata5 = new Catarina4();
        Catarina4 cata6 = new Catarina4();
        Catarina1 cata7 = new Catarina1();
        Catarina3 cata8 = new Catarina3();
        Catarina3 cata9 = new Catarina3();
        Catarina1 cata10 = new Catarina1();
        
        EscaleraBlanca esc1 = new EscaleraBlanca();
        EscaleraBlanca esc2 = new EscaleraBlanca();
        EscaleraBlanca esc3 = new EscaleraBlanca();
        EscaleraBlanca esc4 = new EscaleraBlanca();
        EscaleraBlanca esc5 = new EscaleraBlanca();
        EscaleraBlanca esc6 = new EscaleraBlanca();
        
        //BASES       
        Base3 bas = new Base3();

        Base2 bas1 = new Base2();
        Base2 bas2 = new Base2();
        Base2 bas3 = new Base2();
        Base2 bas4 = new Base2();
        Base2 bas5 = new Base2();
        
        Base1 bas6 = new Base1();
        Base1 bas7 = new Base1();
        Base1 bas8 = new Base1();
        Base1 bas9 = new Base1();
        Base1 bas10 = new Base1();
        Base1 bas11 = new Base1();
        Base1 bas12 = new Base1();
        Base1 bas13 = new Base1();
        Base1 bas14 = new Base1();
        Base1 bas15 = new Base1();
        Base1 bas16 = new Base1();
        Base1 bas17 = new Base1();
        
        addObject(bas, 410,551);
        addObject(bas1, 519, 163);
        addObject(bas2, 261,251);
        addObject(bas3, 198,435);
        addObject(bas4, 624,300);
        addObject(bas5, 735,436);
        
        addObject(bas6, 691,391);
        addObject(bas7, 684,356);
        addObject(bas8, 589,504);
        addObject(bas9, 588,469);
        addObject(bas10, 216,469);
        addObject(bas11, 218,503);
        addObject(bas12, 115,391);
        addObject(bas13, 115,356);
        addObject(bas14, 115,316);
        addObject(bas15, 115,282);
        addObject(bas16, 370,219);
        addObject(bas17, 370,191);
        
        
        // ARBUSTOS 2
        
        Arbusto2 arb1 = new Arbusto2();
        Arbusto2 arb2 = new Arbusto2();
        Arbusto2 arb3 = new Arbusto2();
        Arbusto2 arb4 = new Arbusto2();
        Arbusto2 arb5 = new Arbusto2();
        Arbusto2 arb6 = new Arbusto2();
        Arbusto2 arb7 = new Arbusto2();
        Arbusto2 arb8 = new Arbusto2();
        Arbusto2 arb9 = new Arbusto2();
        Arbusto2 arb10 = new Arbusto2();
        
        addObject(arb1,87,407);
        addObject(arb2,349,407);
        addObject(arb3,93,231);
        addObject(arb4,423,227);
        addObject(arb5,346,147);
        addObject(arb6,680,137);
        addObject(arb7,708,310);
        addObject(arb8,449,300);
        addObject(arb9,564,423);
        addObject(arb10,730,413);
        
        
        //ESCALERAS
        
        addObject(esc1, 370,205);
        addObject(esc2, 114,291);
        addObject(esc3, 114,382);
        addObject(esc4, 212,482);
        addObject(esc5, 682,369);
        addObject(esc6, 586,482);
        
        //CATARINAS
        
        addObject(cata10, 673,435);
        addObject(cata9, 601,333);
        addObject(cata8, 496,333);
        addObject(cata7, 297,438);
        addObject(cata6, 190,250);
        addObject(cata5, 288,252);
        addObject(cata4, 381,252);
        addObject(cata3, 448,163);
        addObject(cata2, 540,163);
        addObject(cata1, 633,163);
        addObject(cata, 134,435);
        
        
        //INSECTOS
        
        Insecto insec1= new Insecto();
        Insecto insec2= new Insecto();
        Insecto insec3= new Insecto();
        Insecto insec4= new Insecto();
        Insecto insec5= new Insecto();
        
        addObject(insec1,276,415);
        addObject(insec2,269,232);
        addObject(insec3,504,142);
        addObject(insec4,558,311);
        addObject(insec5,666,415);
        
        //coraline y puerta
        Puerta pue = new Puerta(this);
        addObject(pue, 631, 107);
        
         Coraline cor2= new Coraline(this);
        addObject(cor2, 402,504);
        
        
        //BRUJA
        
        Bruja bruja = new Bruja();
        
        addObject(bruja,36,294);
    
    }    
    
    /**
     * metodo para maanipular el juego cuando se gana o cuando se pierde
     * crea pantallas diferentes para cada caso
     */
    public void JuegoFinal(int band)
    {
        
        switch(band)
        {
          case 1: GameOver();
                   break;
                     
          case 2: Congratulations();
                     break;
        }
    }
    
    /**
     * crea la pantalla de game Over
     * reproduce un sonido de perder
     */
    public void GameOver()
    {
         limpiaEscenario();
         GreenfootSound x= new GreenfootSound("perder.mp3");
         x.play();
         
         setBackground("fondoGameOver.jpg");
         
         Perdiste game= new Perdiste();
         
         addObject(game,557,284);
    }
    
    /**
     * crea la pantalla de ganar el juego
     * reproduce un sonido de ganar
     */
    public void Congratulations()
    {
         limpiaEscenario();
         GreenfootSound y= new GreenfootSound("ganar.mp3");
         y.play();
         
         setBackground("fondoGanar.jpg");
         
         Congratulations con= new Congratulations();
   
         addObject(con,448,346);
    }
}
